enum LINE {
     //% block="1"
     1,
     //% block="2"
     2,
     //% block="3"
     3,
     //% block="4"
     4,
     //% block="5"
     5,
     //% block="6"
     6,
     //% block="7"
     7,
     //% block="8"
     8,
     //% block="9"
     9,
     //% block="10"
     10,
     //% block="11"
     11,
     //% block="12"
     12,
     //% block="13"
     13
}




//% color="#AA278D" iconWidth=50 iconHeight=40
namespace RC522 {
    //% block="RC522模块初始化，设置SDA引脚[SS]" blockType="command"
    //% SS.shadow="dropdown" SS.options="LINE" SS.defl="LINE.10"
    export function RC522(parameter: any, block: any) {
        let ss_pin = parameter.SS.code;
        let rst_pin = parameter.RST.code;
        Generator.addInclude("MFRC522_1","#include <SPI.h>");
        Generator.addInclude("MFRC522_2","#include <MFRC522.h>");
        Generator.addObject("MFRC522_3","MFRC522",`rfid(${ss_pin},9;`);
        Generator.addObject("MFRC522_5","byte",`nuidPICC[4];`);
      
        Generator.addSetup("MFRC522_6",`SPI.begin(); `);
        Generator.addSetup("MFRC522_7",`rfid.PCD_Init(); `);
    }
        
    //% block="寻找RFID标签" blockType="command"
    export function findRC522(parameter: any, block: any) {
        Generator.addCode(`if ( ! rfid.PICC_IsNewCardPresent())
        return;`);
        Generator.addCode(`if ( ! rfid.PICC_ReadCardSerial())
        return;`);
        Generator.addCode(`MFRC522::PICC_Type piccType = rfid.PICC_GetType(rfid.uid.sak);`);
        Generator.addCode(`if (piccType != MFRC522::PICC_TYPE_MIFARE_MINI &&  
            piccType != MFRC522::PICC_TYPE_MIFARE_1K &&
            piccType != MFRC522::PICC_TYPE_MIFARE_4K) {
            Serial.println("不支持读取此卡类型");
            return;
          }`);
        Generator.addCode(`for (byte i = 0; i < 4; i++) {
            nuidPICC[i] = rfid.uid.uidByte[i];
          }`);  
        Generator.addCode(`rfid.PICC_HaltA();`);
        Generator.addCode(`rfid.PCD_StopCrypto1();`);
    }


    //% block="读取RFID标签" blockType="command"
    export function readRFID(parameter: any, block: any) {
        Generator.addCode(`for (byte i = 0; i < 4; i++) {
            Serial.println(nuidPICC[i], DEC);
          }`);
        Generator.addCode(`Serial.println();`);
        }

    //% block="设置RFID标签[S0],[S1],[S2],[S3]" blockType="command"
    //% S0.shadow="number"  S0.defl=""
    //% S1.shadow="number"  S1.defl=""
    //% S2.shadow="number"  S2.defl=""
    //% S3.shadow="number"  S3.defl=""
    export function setRFID(parameter: any, block: any) {
        let s0 = parameter.S0.code;
        let s1 = parameter.S1.code;
        let s2 = parameter.S2.code;
        let s3 = parameter.S3.code;
            Generator.addObject("setcard_1","byte",`setRFID[4]={${s0},${s1},${s2},${s3}}`);
        }
    
    //% block="读取与设置标签一致" blockType="boolean"
    export function compareRFID(parameter: any, block: any) {
        Generator.addCode(`nuidPICC[0] == setRFID[0] && 
        nuidPICC[1] == setRFID[1] && 
        nuidPICC[2] == setRFID[2] && 
        nuidPICC[3] == setRFID[3]`);
        }
}
